##### 💥 Note: A number of settings and tasks are now only available when `Advanced Mode` is set to true in the settings, including the `Auto Tag` and `Identify` tasks.

### ✨ New Features
* Added Scene play and o-counter history tracking, view and editing. ([#4532](https://github.com/stashapp/stash/pull/4532))
* Added Advanced settings flag. ([#4378](https://github.com/stashapp/stash/pull/4378))
* Added support for setting galleries in Image edit panel and Bulk Edit Image dialog. ([#4573](https://github.com/stashapp/stash/pull/4573)/[#4608](https://github.com/stashapp/stash/pull/4608))
* Added option to generate image thumbnails during generate. ([#4602](https://github.com/stashapp/stash/pull/4602))
* Added Clean Generated Files task. ([#4607](https://github.com/stashapp/stash/pull/4607))
* Added more options to Performer gender filter. ([#4419](https://github.com/stashapp/stash/pull/4419))
* Added image orientation filtering. ([#4404](https://github.com/stashapp/stash/pull/4404))
* Added filtering and sorting of Studios on subsidiary Studio count. ([#4479](https://github.com/stashapp/stash/pull/4479))
* Added image performer age filter. ([#4601](https://github.com/stashapp/stash/pull/4601))

### 🎨 Improvements
* Overhauled the list view for scenes, galleries and performers. ([#4368](https://github.com/stashapp/stash/pull/4368))
* Made grid card fit cards properly within their containers. ([#4514](https://github.com/stashapp/stash/pull/4514))
* Improved the presentation of the toast notifications. ([#4584](https://github.com/stashapp/stash/pull/4584))
* Improved Tag, Studio, Gallery and Movie select controls. ([#4478](https://github.com/stashapp/stash/pull/4478)/[#4493](https://github.com/stashapp/stash/pull/4493)/[#4535](https://github.com/stashapp/stash/pull/4535)/[#4563](https://github.com/stashapp/stash/pull/4563))
* Improve sorting of results when entering text in select fields. ([#4528](https://github.com/stashapp/stash/pull/4528))
* Add disambiguation to performer link and performer select values. ([#4541](https://github.com/stashapp/stash/pull/4541))
* Show upgradable packages only when checking for updates in the package managers. ([#4599](https://github.com/stashapp/stash/pull/4599))
* Include primary tag name in Scene Marker search and sort. ([#4606](https://github.com/stashapp/stash/pull/4606))
* Improved presentation of scene queue. ([#4448](https://github.com/stashapp/stash/pull/4448))
* Improved zip file move detection. ([#4374](https://github.com/stashapp/stash/pull/4374))
* Saving images will now name them based on the original filename. ([#4616](https://github.com/stashapp/stash/pull/4616))
* Improved scene tagger matching prioritisation. ([#4618](https://github.com/stashapp/stash/pull/4618))
* Added support for disabling mobile media-viewer's fullscreen auto-rotate. ([#4416](https://github.com/stashapp/stash/pull/4416))
* Defer loading edit panel data until needed. ([#4564](https://github.com/stashapp/stash/pull/4564))
* Performer stash-box draft now includes the Disambiguation field. ([#4122](https://github.com/stashapp/stash/pull/4122))

### 🐛 Bug fixes
* **[0.25.1]** Fixed captions with embedded timestamps rendering incorrectly. ([#4682](https://github.com/stashapp/stash/pull/4682))
* **[0.25.1]** Fixed buffering time included in scene play time. ([#4670](https://github.com/stashapp/stash/pull/4670))
* **[0.25.1]** Fixed medium fingerprint match colour. ([#4662](https://github.com/stashapp/stash/pull/4662))
* **[0.25.1]** Fixed image clip webm files not being cleaned by Clean Generate task. ([#4657](https://github.com/stashapp/stash/pull/4657))
* **[0.25.1]** Fixed ffmpeg error when transcoding files where max transcode size is set. ([#4660](https://github.com/stashapp/stash/pull/4660))
* Fixed invalid share causing error during cleaning. ([#4570](https://github.com/stashapp/stash/pull/4570))
* Fixed stash ids being removed when tagging Studio using the Studio Tagger. ([#4572](https://github.com/stashapp/stash/pull/4572))
* Fixed Plugin manager failing to get any updates if any installed sources are not found. ([#4591](https://github.com/stashapp/stash/pull/4591))
* Fixed `.forcegallery` file not being honoured when re-scanning after adding the file. ([#4627](https://github.com/stashapp/stash/pull/4627))
* Fixed Gallery Image filtering. ([#4535](https://github.com/stashapp/stash/pull/4535))
* Fixed Studio overlay not being shown on Image cards, and Studio text not being shown on Gallery cards. ([#4540](https://github.com/stashapp/stash/pull/4540))
* Wrap grid card popovers. ([#4539](https://github.com/stashapp/stash/pull/4539))
* Fix merge scene not deleting generated files. ([#4567](https://github.com/stashapp/stash/pull/4567))
* Fixed auto tag from object not honouring the ignore autotag flag. ([#4610](https://github.com/stashapp/stash/pull/4610))
* Fixed moved files causing re-generation of phashes. ([#4598](https://github.com/stashapp/stash/pull/4598))
* Fixed Movie scene sorting in Movie view. ([#4588](https://github.com/stashapp/stash/pull/4588))
* Fixed `baseURL` not being applied to some links. ([#4501](https://github.com/stashapp/stash/pull/4501))
* Fixed country selector in bulk performer edit dialog. ([#4565](https://github.com/stashapp/stash/pull/4565))
* Fixed image clips not upscaling in lightbox. ([#4569](https://github.com/stashapp/stash/pull/4569))
* Fixed `bmp` files being treated as video files in the lightbox. ([#4653](https://github.com/stashapp/stash/pull/4653))
* Fixed performer penis length being truncated to integer. ([#4630](https://github.com/stashapp/stash/pull/4630))
* Fixed heatmap generating repeated segments where there is no action. ([#4557](https://github.com/stashapp/stash/pull/4557))
* Fixed media decode error not switching to next streaming format. ([#4506](https://github.com/stashapp/stash/pull/4506))
* Fixed image scraping not using proxy. ([#4637](https://github.com/stashapp/stash/pull/4637))
* Fixed broken favicon after logging in using Firefox. ([#4498](https://github.com/stashapp/stash/pull/4498))
* Moved tag hover popover to the right. ([#4593](https://github.com/stashapp/stash/pull/4593))
* Fixed weird 404 behaviour in plugin assets handler. ([#4597](https://github.com/stashapp/stash/pull/4597))

### Plugin API changes
* Added `Mousetrap` and `MousetrapPause` to `PluginApi.libraries`. ([#4489](https://github.com/stashapp/stash/pull/4489))
* Added `useToast` to `PluginApi.hooks`. ([#4546](https://github.com/stashapp/stash/pull/4546))
* Exposed Studio, Performer, Tag and Gallery selects, and date, country and folder inputs in `PluginApi.components`. ([#4546](https://github.com/stashapp/stash/pull/4546))
* Made `task_name` parameter optional, added an optional `description` parameter and deprecated `args` for a generic map parameter `args_map` in `runPluginTask`. ([#4603](https://github.com/stashapp/stash/pull/4603))
* Added `runPluginOperation` to run synchronous plugin operations with a return value, without using the task manager. ([#4603](https://github.com/stashapp/stash/pull/4603))
* Added `PluginApi.Event.addEventListener` and `stash:location` event dispatching.
* Relaxed plugin cyclic loop detection to allow up to ten loops. ([#4625](https://github.com/stashapp/stash/pull/4625))
